import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

public class VendingMachineTest {
	private vendingMachine vm1;
	@Before
	public void setUp() throws Exception {
		vm1= new vendingMachine();
	}

	@After
	public void tearDown() throws Exception {
		vm1 = null;
	}
	
	@Test
	//prime path 1: [s_0, s_2, s_3, s_0, s_1, s_3]
	//addChoc, coin, getChoc, coin, addChoc
	public void test1() {
		int change;
		//addChoc
		vm1.addChoc("choc1");
		assertEquals(1, vm1.getStock().size());
	    assertEquals(0,vm1.getCredit());
	    //coin
	    vm1.coin(100);
	    assertEquals(100, vm1.getCredit());
	    assertEquals(1, vm1.getStock().size());
	    //getChoc
	    StringBuffer choc = new StringBuffer().append("Choc1");
	    change = vm1.getChoc(choc);
	    assertEquals(5, choc.length());
	    assertEquals(0, vm1.getCredit());
	    assertEquals(10, change);
	    assertEquals(0, vm1.getStock().size());
	    //coin
	    vm1.coin(10);
	    assertEquals(10, vm1.getCredit());
	    assertEquals(0, vm1.getStock().size());
	    vm1.coin(25);
	    assertEquals(35, vm1.getCredit());
	    assertEquals(0, vm1.getStock().size());
	    vm1.coin(25);
	    assertEquals(60, vm1.getCredit());
	    assertEquals(0, vm1.getStock().size());
	    vm1.coin(25);
	    assertEquals(85, vm1.getCredit());
	    assertEquals(0, vm1.getStock().size());
	    vm1.coin(25);
	    assertEquals(110, vm1.getCredit());
	    assertEquals(0, vm1.getStock().size());
	    //addChoc
	    vm1.addChoc("Choc2");
	    assertEquals(110, vm1.getCredit());
	    assertEquals(1, vm1.getStock().size());
	    vm1.addChoc("Choc3");
	    assertEquals(110, vm1.getCredit());
	    assertEquals(2, vm1.getStock().size());
	    System.out.println("executed");
	}
	
	@Test
	//prime path 2: [s_0, s_1, s_3, s_0, s_1, s_3]
	//coin, addChoc, getChoc, coin, addChoc
	public void test2() {
		int change;
		//coin
	    vm1.coin(100);
	    assertEquals(100, vm1.getCredit());
	    assertEquals(0, vm1.getStock().size());
	    //addChoc
	    vm1.addChoc("Choc2");
	    assertEquals(100, vm1.getCredit());
	    assertEquals(1, vm1.getStock().size());
	    //getChoc
	    StringBuffer choc = new StringBuffer().append("Choc1");
	    change = vm1.getChoc(choc);
	    assertEquals(5, choc.length());
	    assertEquals(0, vm1.getCredit());
	    assertEquals(10, change);
	    assertEquals(0, vm1.getStock().size());
		//coin
	    vm1.coin(10);
	    assertEquals(10, vm1.getCredit());
	    assertEquals(0, vm1.getStock().size());
	    //addChoc
	    vm1.addChoc("Choc2");
	    assertEquals(10, vm1.getCredit());
	    assertEquals(1, vm1.getStock().size());
	    vm1.addChoc("Choc3");
	    assertEquals(10, vm1.getCredit());
	    assertEquals(2, vm1.getStock().size());
	}

}
